﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Alpha.aspx.cs" Inherits="MS_OSPFM.Alpha" %>
<%@ Register Assembly="WebEdition" Namespace="ThinkGeo.MapSuite.WebEdition" TagPrefix="cc1" %>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title></title>
    <link href="Assets/StyleSheet/OSPFM.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .tooltips
        {    
            position:absolute; 
            width:80px; 
            height:20px; 
            font-size:10px; 
            font-family:Verdana; 
            padding:4px; 
            background-color:#ffffe7; 
            display:none; 
            border:solid 1px #000000; 
            z-index:999;
        }
        .style1
        {
            width: 100%;
        }
        #txtScaleLevel
        {
            width: 30px;
        }
    </style>
    <script type="text/javascript">
        var shapeOverlay = null;
        var currentFeature = null;
        var styleRed = null;

        var vScale; //For passing scale value to code behind for tool tip

        var OnMapCreating = function() {
            OpenLayers.Layer.VirtualEarth.prototype.MAX_ZOOM_LEVEL = 19;
        }

        var timer;
        var delayInterval = 1000;
        var clientX, clientY;
        var showToolTips = function(result, context) {
            if (result != '' && result != null) {
                context.innerHTML = result;
                context.style.left = (clientX - 40) + 'px';
                context.style.top = (clientY - 20) + 'px';
                context.style.display = 'block';
            }
        };

        var beginToolTipsRequest = function() {
            var lonlat = this.map.getLonLatFromViewPortPx(this.xy);
            var args = lonlat.lon + ',' + lonlat.lat + ',' + vScale; 
            var context = $get('divTooltips');
            //alert(vScale);
            <%=ClientScript.GetCallbackEventReference(Page, "args", "showToolTips", "context") %>
        };
        
        var getDelegate = function(sender, handler) {
            return function() {
                handler.apply(sender, arguments);
            }
        }


        function OnMapCreated(map) {
            
            map.events.register('mousemove', map, function(e){
            if(timer){
                window.clearTimeout(timer);
                timer = null;
            }
            $get('divTooltips').style.display = 'none';
            var beginToolTipsRequestDelegate = function(sender){
                return function(){
                    beginToolTipsRequest.apply(sender, arguments);
                }
            }
            clientX = e.clientX;
            clientY = e.clientY;
            timer = window.setTimeout(beginToolTipsRequestDelegate({xy:e.xy, map:this}), delayInterval);
            });
            
            // Display the toolbar of VE, but it can't work.
            var layer = map.getLayer("VirtualEarth Map");
            if (layer != null) {
                layer.mapObject.vemapcontrol.SetAnimationEnabled(false);
                //alert('test');
                var str = map.getZoom() + 1;
                document.getElementById('txtScaleLevel').value = str;
                //alert(document.getElementById('txtScaleLevel').value);
                //layer.mapObject.ShowDashboard();

                shapeOverlay = new OpenLayers.Layer.Vector({ style: { fillColor: 'red'} });
                map.addLayer(shapeOverlay);

                styleRed = {
                    strokeColor: "red",
                    strokeWidth: 1,
                    strokeDashstyle: "solid",
                    pointRadius: 6,
                    fillColor: 'red'
                };
            }

            // Get Current Zoomlevel.
            map.events.register('zoomend', map, function(e) {
                var str = map.getZoom() + 1;
                //alert(str);
                document.getElementById('txtScaleLevel').value = str;
                //                         //alert(document.getElementById('txtScaleLevel').value);

            });
        }

        var linkOver = function(obj) {
            if (shapeOverlay != null) {
                currentFeature = new OpenLayers.Format.WKT().read(obj.wkt);
                currentFeature.style = styleRed;
                shapeOverlay.addFeatures([currentFeature]);
            }
        };
        var linkOut = function() {
            if (shapeOverlay && currentFeature) {
                shapeOverlay.destroyFeatures([currentFeature]);
            }
        };
        
        // to work around tooltip bug in 3.1.16
        var postData = decodeURIComponent(__theFormPostData);
        var startData = postData.substr(0, postData.indexOf('&'));
        var endData = postData.substr(postData.indexOf('&'), postData.length - postData.indexOf('&'));
        __theFormPostData = startData + ',' + map.getScale().toString() + endData;


    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:ScriptManager ID="ScriptManager1" runat="server">
        </asp:ScriptManager>

        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>

        
        <table class="style1" border="0">
        <tr>
            <td>
                <asp:Image ID="Image1" runat="server" 
                    ImageUrl="~/Assets/Images/ospfm_site_artwork.jpg" Height="50px" Width="620px" /></td>
        </tr>
        <tr>
             <td colspan="2">
                <table border="0">
                    <tr>
                        <td>
                            <table class="VEToolTableLayout">
                                <tr class="VEToolTableLayout" >
                                  <td class="VEToolTableLayout"><asp:Button ID="btnRoad" CssClass="Button" 
                                          runat="server" Text="Road" 
                                          OnClientClick="Map1.SetCurrentBackgroundMapType(VEMapStyle.Road); return false;" 
                                          ToolTip="Click to see Road View" /></td>
                                  <td class="VEToolTableLayout"><asp:Button ID="btnSatellite" CssClass="Button" 
                                          runat="server" Text="Aerial" 
                                          OnClientClick="Map1.SetCurrentBackgroundMapType(VEMapStyle.Aerial); return false;" 
                                          ToolTip="Click to see Aerial View" /></td>
                                  <td class="VEToolTableLayout"><asp:Button ID="btnPhysical" CssClass="Button" 
                                          runat="server" Text="Hybrid" 
                                          OnClientClick="Map1.SetCurrentBackgroundMapType(VEMapStyle.Hybrid); return false;" 
                                          ToolTip="Click to see Hybrid View" /></td>
                                   <td class="VEToolTableLayout"><asp:Button ID="btnBirdEye" CssClass="Button" 
                                           runat="server" Text="BirdEye" 
                                           OnClientClick="Map1.SetCurrentBackgroundMapType(VEMapStyle.Birdseye); return false;" 
                                           ToolTip="Click to see BirdEye View" /></td>
                                </tr>
                              </table>
                        </td>
                        <td>
                            <table class="VEToolTableLayout">
                                <tr class="VEToolTableLayout" >
                                    <td class="VEToolTableLayout" ><input id="txtScaleLevel" runat="server" type="text" class="ZoomScale" 
                                            title="Current Zoom Level" /></td>
                                    <td class="VEToolTableLayout" ><input type="image" value="Draw Rectangle" 
                                            onclick="Map1.SetDrawMode('Rectangle');return false;" 
                                            src="Assets/Images/rectangle28.png"  
                                            title="Draw an area on map to get feature selection" 
                                            style="height: 14px; width: 23px" /></td>
                                    <td class="VEToolTableLayout" ><asp:Button ID="btnAttribSearch" CssClass="Button" 
                                            runat="server" Text="Atrb. Srch." ToolTip="Click for Attribute Search" /></td>
                                    <td class="VEToolTableLayout" ><asp:Button ID="btnHelp" CssClass="Button" 
                                            runat="server" Text="Help" ToolTip="Click for Help" /></td>
                                </tr>
                              </table>
                        </td>
                        <td>
                            <table class="VEToolTableLayout">
                                <tr class="VEToolTableLayout" >
                                  <td class="VEToolTableLayout"><asp:Button ID="btnLatLongSearch" CssClass="Button" 
                                          runat="server" Text="Search (Long, Lat)" 
                                          ToolTip="Type Longitude, Latitude value in next box" 
                                          onclick="btnLatLongSearch_Click" /></td>
                                  <td class="VEToolTableLayout"><asp:TextBox ID="txtLat" runat="server" ToolTip="Provide Long, Lat values (Ex: '-118.25, 34.09')" CssClass="GeoCodeTextBox">-118.25, 34.09</asp:TextBox></td>
                                  <td class="VEToolTableLayout">
                                      <asp:Button ID="btnAddSearch" CssClass="Button" 
                                          runat="server" Text="Search by Address" 
                                          ToolTip="Type address to search" onclick="btnAddSearch_Click" /></td>
                                   <td class="VEToolTableLayout"><asp:TextBox ID="TxtAddress" Text="2400 Glenville Dr" Width="210px" runat="server" CssClass="GeoCodeTextBox"></asp:TextBox></td>
                                </tr>
                              </table>
                        </td>
                    </tr>
                </table>
                
            </td>
        </tr>
        <tr>
            <td width="85%">
<%--                <asp:UpdatePanel ID="upMap" runat="server">
                <ContentTemplate>
--%>                     <cc1:Map ID="Map1" runat="server" Width="100%" Height="650px" 
                         ontrackshapefinished="Map1_TrackShapeFinished"></cc1:Map>    
<%--                </ContentTemplate>
                </asp:UpdatePanel>
--%>            </td>
            <td valign="top" width="15%">
                <asp:UpdatePanel ID="upTabs" runat="server">
                <ContentTemplate>
                    <ajaxToolkit:TabContainer ID="Tabs" runat="server" ActiveTabIndex="1" 
                        Width="250px" Height="610px" AutoPostBack="True" 
                        onactivetabchanged="Tabs_ActiveTabChanged">
                    <ajaxToolkit:TabPanel runat="server" ID="Panel1" HeaderText="Legend/Layer">
                        <ContentTemplate>
                            <br /><br />
                            Legend text goes here.
                        </ContentTemplate>
                    </ajaxToolkit:TabPanel>
        
                     <ajaxToolkit:TabPanel runat="server" ID="Panel2" HeaderText="Feature Selection">
                         <HeaderTemplate>
                             Feature Selection
                         </HeaderTemplate>
                        <ContentTemplate>
                            <div>Selected features will be displayed  here:</div>
                               <asp:Panel runat="server" ID="panel">
                               </asp:Panel>
                                <asp:TreeView ID="TreeView1" runat="server" ShowLines="True"  
                                    EnableTheming="True" 
                                    onselectednodechanged="TreeView1_SelectedNodeChanged" 
                                CssClass="TreeView">
                                </asp:TreeView>    
                            <br />
                        </ContentTemplate>
                    </ajaxToolkit:TabPanel>
                </ajaxToolkit:TabContainer>
                </ContentTemplate>
                </asp:UpdatePanel>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <asp:Panel ID="ResultPanel" runat="server" BorderWidth="1" Visible="False">
                     <table>
                         <tr>
                            <td width="100%">
                                <asp:ListBox ID="listboxFindResults" runat="server" Height="80px" Width="100%" AutoPostBack="True" OnSelectedIndexChanged="listboxFindResults_SelectedIndexChanged"></asp:ListBox>
                            </td>
                            <td valign="top">
                                <asp:ImageButton ID="ImageButton1" runat="server" ImageUrl="close.gif" 
                                    onclick="ImageButton1_Click" />
                            </td>
                           </tr>
                      </table>
                </asp:Panel>

            </td>
        </tr>
        <tr>
            <td class="MapBottom" colspan="2">
                <asp:HyperLink ID="HLmsdn" runat="server" 
                    NavigateUrl="http://msdn.microsoft.com/en-us/default.aspx" Target="_blank">MSDN</asp:HyperLink>
                    &nbsp;&nbsp;
                 <a href="mailto:support@verizonbusiness.com?subject=OSPFM Online &body=Your feedback appreciated!">Feedbackk</a>   
                 &nbsp;&nbsp;
            </td>
        </tr>
    </table>
    
        </ContentTemplate>
        </asp:UpdatePanel>

    </div>
    <div id="divTooltips" class="tooltips">
    </div>
    </form>
</body>
</html>
